"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var api_1 = require("@src/api");
function useTimeoutFn(callback, ms, runOnMount) {
    if (ms === void 0) { ms = 0; }
    if (runOnMount === void 0) { runOnMount = true; }
    var isReady = api_1.ref(false);
    var isIdle = api_1.ref(!runOnMount);
    var timeout = null;
    var cancel = function () {
        isReady.value = null;
        if (timeout) {
            clearTimeout(timeout);
            timeout = null;
        }
    };
    var setTimer = function () {
        isReady.value = false;
        if (isIdle.value)
            isIdle.value = false;
        if (timeout)
            clearTimeout(timeout);
        timeout = setTimeout(function () {
            isReady.value = true;
            callback();
            timeout = null;
        }, ms);
    };
    api_1.onMounted(function () { return runOnMount && setTimer(); });
    api_1.onUnmounted(cancel);
    return { isReady: isReady, isIdle: isIdle, cancel: cancel, start: setTimer };
}
exports.useTimeoutFn = useTimeoutFn;
